#!/usr/bin/perl -w
use QueryData;
print "Loading Dictionary......please wait\n";
my $bm=QueryData->new;
while(1)
{
   
    # Print all the options to standard output
    print "********************************\n";
    print "Welcome to the BigMac Dictionary\n";
    print "********************************\n";
    print "Options:\n";
    print "---------------------------------------\n";
    print "1.Definitions\n";
    print "2.Phrases\n";
    print "3.Topics\n";
    print "4.Usage\n";
    print "5.Different Forms\n";
    print "6.Parts of Speech\n";
    print "7.Pronounciation\n";
    print "8.Variants\n";
    print "9.Abbreviations\n";
    print "10.Contexts\n";
    print "11.References\n";
    print "12.Get all words for a topic\n";
    print "13.Thesaurus Entry\n";
    print "14.Words Given POS\n";
    print "15.Adjectives\n";
    print "16.Nouns given Letter\n";
    print "17.Words having a given word in their definitions.\n";
    print "18.Words having the same semantic code as given word.\n";
    print "0.Exit\n";
    print "----------------------------------------\n"; 
    print "Enter option:";
    chomp($option = <STDIN>);

   
    # If user enters option "0" then exit

    if($option == 0)
    {
	exit;
    }
    else
    {

	# Check if user wants to redirect output to a file

        $flag = 0;
	print "Do you want to redirect output to file:";
	chomp($op = <STDIN>);
	if($op=~/Y|y/)
	{
	    $flag = 1;
	    print "Enter File Name:\n";
	    chomp($filename = <STDIN>);
	    print "Redirecting output to $filename........\n";
	    $filename = ">".$filename;
	    open(FILE,$filename) || die "\nError in opening file $filename\n";
	}
	else
	{
	    print "Redirecting output to Standard Output.......\n";
	}
      
	# Check for option entered and perform the appropriate operation
	# If option is 1 the get sense definitions for the word

	if($option == 1)
	{
	    print "Enter word:";
	    chomp($word = <STDIN>);

	    # Check if flag is set to 1,if so the redirect output
	    # to the specified file,if not redirect to standard
	    # output

	    if($flag == 1)
	    {
		    print FILE $bm->get_sense_defs($word);
	    }
	    else
	    {
			@senses=$bm->get_sense_defs($word);
			$i=1;
			foreach $sense(@senses)
			{
				print "\nDefinition $i=$sense";
				$i++;
			}
#		    print $bm->get_sense_defs($word);
#		    print "\n";
	    }
	}

	# If option entered is 2 the get phrases for the given word

        if($option == 2)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
		    print FILE $bm->get_phrases($word);
            }
	    else
	    {
                    	@phrases=$bm->get_phrases($word);
			$i=1;
			foreach $phrase(@phrases)
			{
				print "\nPhrase $i=$phrase";
				$i++;
			}
		   # print $bm->get_phrases($word);
		   # print "\n";
	    }
	}

	# If option is 3 the get topics for the given word

        if($option == 3)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_topics($word);
	      
            }
	    else
	    {
	            	@topics=$bm->get_topics($word);
			$i=1;
			foreach $topic(@topics)
			{
				print "\nTopic $i=$topic";
				$i++;
			}
		   # print $bm->get_topics($word);
		   # print "\n";
	      
	    }
	    
        }


	# Get usage for the word

	if($option == 4)
	{
            print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_usage($word);
	        
	    }
	    else
	    {
                    	@usage=$bm->get_usage($word);
			$i=1;
			foreach $usage(@usage)
			{
				print "\nUsage $i=$usage";
				$i++;
			}
	           # print $bm->get_usage($word);
		   # print "\n";
	       
	    }
	    
        }

	# Get different forms for a word

	if($option == 5)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_forms($word);
	       
            }
	    else
	    {

                   	@forms=$bm->get_forms($word);
			$i=1;
			foreach $form(@forms)
			{
				print "\nForms $i=$form";
				$i++;
			}
	
		    #print $bm->get_forms($word);
		    #print "\n";
	        
	    }
	    
        }

	# Get Parts of Speech for a word

	if($option == 6)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_pos($word);
	        
            }
	    else
	    {
                    	@pos=$bm->get_pos($word);
			$i=1;
			foreach $pos(@pos)
			{
				print "\nPOS $i=$pos";
				$i++;
			}
	
		   # print $bm->get_pos($word);
		   # print "\n";
	        
	    }
	    
        }

	# Get pronounciation for a word

	if($option == 7)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_pron($word);
	        
            }
	    else
	    {
                   	@pron=$bm->get_pron($word);
			$i=1;
			foreach $pron(@pron)
			{
				print "\nPronounciation $i=$pron";
				$i++;
			}
	
		   # print $bm->get_pron($word);
		   # print "\n";
	        
	    }
	    
        }

	# Get variants for a word

	if($option == 8)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_variants($word);
	        
            }
	    else
	    {
                    	@variants=$bm->get_variants($word);
			$i=1;
			foreach $variant(@variants)
			{
				print "\nVariants $i=$variant";
				$i++;
			}
	            #print $bm->get_variants($word);
		    #print "\n";
	        
	    }
	    
        }

	# Get abbreviations for a word

	if($option == 9)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_abbreviations($word);
	        
            }
	    else
	    {
	            	@abbrv=$bm->get_abbreviations($word);
			$i=1;
			foreach $abbrv(@abbrv)
			{
				print "\nAbbreviation $i=$abbrv";
				$i++;
			}
		    #print $bm->get_abbreviations($word);
		    #print "\n";
	        
	    }
	    

        }
	
	# Get the different contexts of the word

	if($option == 10)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_contexts($word);
	        
            }
	    else
	    {
	            	@contexts=$bm->get_contexts($word);
			$i=1;
			foreach $context(@contexts)
			{
				print "\nContext $i=$context";
				$i++;
			}
		   # print $bm->get_contexts($word);
		   # print "\n";
	        
	    }
	    
        }

        # Get references for a word

	if($option == 11)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_references($word);
	        
            }
	    else
	    {
		        @ref=$bm->get_references($word);
			$i=1;
			foreach $ref(@ref)
			{
				print "\nReferences $i=$ref";
				$i++;
			}
		   # print $bm->get_references($word);
		   # print "\n";
	        
	    }
	    
        }
	

	# Get all the words for any given topic

	if($option == 12)
	{
	    print "Enter Topic:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_words_for_topic($word);
	        
            }
	    else
	    {
                    	@get_words=$bm->get_words_for_topic($word);
			$i=1;
			foreach $get_words(@get_words)
			{
				print "\nWords for the given topic $i=$get_words";
				$i++;
			}
	
		    #print $bm->get_words_for_topic($word);
		    #print "\n";
	        
	    }
	    
        }

	# Get thesaurus entry for a word

	if($option == 13)
	{
	    print "Enter Word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
                 print FILE $bm->get_thes($word);
	        
            }
	    else
	    {
	            	@thes=$bm->get_thes($word);
			$i=1;
			foreach $thes(@thes)
			{
				print "\nThesaurus $i=$thes";
				$i++;
			}
		   # print $bm->get_thes($word);
		   # print "\n";
	        
	    }
	    
        }

	# Get all the words for any the given Part of Speech

	if($option == 14)
	{
	    print "Enter POS:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_words_given_pos($word);
	        
            }
	    else
	    {
                	@get_words_pos=$bm->get_words_given_pos($word);
			$i=1;
			foreach $get_words_pos(@get_words_pos)
			{
				print "\nWords with given POS $i=$get_words_pos";
				$i++;
			}
		#     print $bm->get_words_given_pos($word);
		#     print "\n";
		 
             }
	    
        }

	# Get all the adjectives

	if($option == 15)
	{
	    
           
            if($flag == 1)
            {
               
		    print FILE $bm->get_adjs();
	        
            }
	    else
	    {
                   	@adjs=$bm->get_adjs();
			$i=1;
			foreach $adj(@adjs)
			{
				print "\nAdjectives $i=$adj";
				$i++;
			}
	
		   # print $bm->get_adjs();
		   # print "\n";
	        
	    }
	    
        }

	# Get all nouns forms for a given alphabet

        if($option == 16)
	{
	    print "Enter Starting Letter:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {
               
		    print FILE $bm->get_nouns_given_letter($word);
	        
            }
             else
             {
                     	@nouns_letter=$bm->get_nouns_given_letter($word);
			$i=1;
			foreach $nouns_letter(@nouns_letter)
			{
				print "\nNouns with given letter $i=$nouns_letter";
				$i++;
			}  
		     #print $bm->get_nouns_given_letter($word);
		     #print "\n";
		
             }
	    
        }
	if($option==17)
	{
		print "Enter word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {

                    print FILE $bm->get_words_given_words_in_def($word);

            }
             else
             {
                        @words=$bm->get_words_given_words_in_def($word);
                        $i=1;
                        foreach $word(@words)
                        {
                                print "\nWord $i=$word";
                                $i++;
                        }

             }

	}	
       if($option==18) 
	{
		print "Enter word:";
            chomp($word = <STDIN>);
            if($flag == 1)
            {

                    print FILE $bm->get_words_given_word_thes($word);

            }
             else
             {
                        %semantic=$bm->get_words_given_word_thes($word);
                        $i=1;
			foreach $class(keys %semantic)
			{
				@words=@{$semantic{$class}};
	                        foreach $word(@words)
        	                {
                	                print "\nWord $i=$word";
                        	        $i++;
                        	}
			}

             }
		
	}
	
        
    }
    print "\nPress any key to continue.....\n";
    <STDIN>;
} 

